﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using SilverlightCache.ServiceReference1;
using System.Collections.ObjectModel;

namespace SilverlightCache
{
    public partial class MainPage : UserControl
    {
        Service1Client client = new Service1Client();
        const string KEY_CACHE = "key_cache";

        public MainPage()
        {
            InitializeComponent();
            client.DoWorkCompleted += new EventHandler<DoWorkCompletedEventArgs>(client_DoWorkCompleted);
        }

        void client_DoWorkCompleted(object sender, DoWorkCompletedEventArgs e)
        {
            Cache.Instance[KEY_CACHE] = e.Result;
            Message("Service", "List's count:"+e.Result.Count().ToString());
        }

        private void btnTest_Click(object sender, RoutedEventArgs e)
        {
            if (Cache.Instance[KEY_CACHE] == null)
            {
                client.DoWorkAsync();
            }
            else
            {
                Message("Cache", "List's count:" + (Cache.Instance[KEY_CACHE] as ObservableCollection<Something>).Count().ToString());
            }
        }

        void Message(string from, string msg)
        {
            MessageBox.Show(string.Format("Data from {0}, msg is {1}", from, msg));
        }
    }
}
